"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("react");
const Effects = __importStar(require("./effects"));
exports.Effects = Effects;
const addEffects = 0;
const removeEffects = 1;
function useElmish(reducer, initializer) {
    const [effects, effectsDispatch] = react_1.useReducer((prev, [actionType, effects]) => {
        switch (actionType) {
            case 0:
                return [].concat(prev, effects);
            case 1:
                return prev.filter(x => !effects.includes(x));
        }
    }, []);
    const [state, dispatch] = react_1.useReducer((prevState, action) => {
        let [nextState, nextEffects] = reducer(prevState, action);
        if (nextEffects.length > 0) {
            effectsDispatch([addEffects, nextEffects]);
        }
        return nextState;
    }, null, _ => {
        const [state, eff] = initializer();
        if (eff.length > 0) {
            effectsDispatch([addEffects, eff]);
        }
        return state;
    });
    react_1.useEffect(() => {
        if (effects.length > 0) {
            const eff = [...effects];
            effectsDispatch([removeEffects, eff]);
            eff.forEach((x) => x(dispatch));
        }
    });
    return [state, dispatch];
}
exports.useElmish = useElmish;
exports.default = useElmish;
